#! /usr/bin/ruby 
require 'resolv'
require 'socket'

addresses = Hash.new do |h,k| 
	h[k] = Array.new 
end

me = Resolv.getname(Resolv.getaddress(Socket.gethostname))
STDERR.puts "I am #{me}"

[133, 134,135,136,137].each do |icmpcode|
	["out", "in"].each do |direction|
		puts "spdadd ::0/0 ::0/0 icmp6 #{icmpcode},0 -P #{direction} none;"
	end
end

mode = 0

ARGV.each do |arg|
	if(arg == '-4') then mode = 4; next end
	if(arg == '-6') then mode = 6; next end
	STDERR.puts "Looking up #{arg}"
	if(mode == 4) then
		[Resolv::DNS::Resource::IN::A]
	elsif(mode == 6) then
		[Resolv::DNS::Resource::IN::AAAA]
	else
		[Resolv::DNS::Resource::IN::A, Resolv::DNS::Resource::IN::AAAA]
	end.each do |type|
		Resolv::DNS.new.each_resource(arg, type) do |address|
			STDERR.puts "\t#{address.address.to_s}"
			addresses[arg] << address
		end
	end
end

addresses.keys.sort.each do |h1|
	addresses.keys.sort.each do |h2|
		next if h1 == h2
		next if h1 != me and h2 != me
		puts "# #{h1} - #{h2}"
		addresses[h1].each do |addr1|
			addresses[h2].each do |addr2|
				next if addr1 == addr2
				next if addr1.class != addr2.class 
				puts "spdadd #{addr1.address} #{addr2.address} any -P in ipsec\n\tesp/transport//require\n\tah/transport//require;"
				puts "spdadd #{addr2.address} #{addr1.address} any -P out ipsec\n\tesp/transport//require\n\tah/transport//require;"
			end
		end
	end
end
